diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index 001586e41..041b7f075 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -126,7 +126,7 @@ public abstract class MenuAbstract
 	 * The returned ItemStack is used to check if the client has the same items as the server.
 	 * If they are different, the server sends the inventory again.
 	 */
-	public ItemStack clicked(InventoryAction action, int[] args, Player player) {
+	public @Nullable ItemStack clicked(final @NotNull InventoryAction action, final int @Nullable [] args, final @NotNull Player player) {
 		if(action.requireCreative()) {
 			if(player.getGamemode().hasBlockConsumption()) {
                 LOGGER.warn("Player {} used a creative inventory action but is not in creative mode!", player.username);
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
index ebfbbca85..4495cfc63 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
@@ -72,7 +72,7 @@ public class MenuActivator extends MenuAbstract {
 	}
 
 	@Override
-	public ItemStack clicked(InventoryAction action, int[] args, Player player) {
+	public ItemStack clicked(@NotNull InventoryAction action, int @NotNull [] args, @NotNull Player player) {
 		if (action == InventoryAction.LOCK) {
 			activator.lockSlot(args[0], !activator.locked(args[0]));
 			return null;
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
index 6547d228e..dc27d2b6b 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
@@ -75,7 +75,7 @@ public class MenuCrafting extends MenuAbstract {
 
     @Override
     public boolean stillValid(@NotNull Player player) {
-        if (this.world.getBlockId(this.tilePos) != Blocks.WORKBENCH.id()) {
+        if (this.world.getBlockType(this.tilePos) != Blocks.WORKBENCH) {
             return false;
         }
         return player.distanceToSqr((double) this.tilePos.x + 0.5D, (double) this.tilePos.y + 0.5D, (double) this.tilePos.z + 0.5D) <= 64D;
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
index 46295eaee..51d6a512b 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
@@ -17,7 +17,7 @@ public class MenuGuidebook extends MenuAbstract
 	}
 
 	@Override
-	public ItemStack clicked(InventoryAction action, int[] args, Player player) {
+	public ItemStack clicked(@NotNull InventoryAction action, int @NotNull [] args, @NotNull Player player) {
 		return null;
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index 03670e0ce..ce265fc71 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -4,7 +4,6 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
@@ -17,6 +16,7 @@ import org.jetbrains.annotations.Nullable;
 import java.util.Collection;
 import java.util.HashMap;
 import java.util.Map;
+import java.util.Objects;
 
 public class BlocksContainer implements MutableWorldSource {
     public final @NotNull World world;
@@ -38,8 +38,8 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public boolean setBlockId(final @NotNull TilePosc tilePos, final int id) {
-        this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(id, 0, null));
+    public boolean setBlockType(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(block, 0, null));
         return true;
     }
 
@@ -47,7 +47,7 @@ public class BlocksContainer implements MutableWorldSource {
     public void setBlock(final int x, final int y, final int z, final int id, final int data, final @Nullable TileEntity tileEntity) {
         final @NotNull TilePos tilePos = new TilePos(x, y, z);
 
-        this.setBlockIdData(tilePos, id, data);
+        this.setBlockTypeData(tilePos, Objects.requireNonNull(Blocks.getBlock(id)), data);
         if (tileEntity != null) {
             this.setTileEntity(tilePos, tileEntity);
         }
@@ -59,15 +59,15 @@ public class BlocksContainer implements MutableWorldSource {
         if (entry != null) {
             entry.data = data;
         } else {
-            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockId(tilePos), data, this.world.getTileEntity(tilePos)));
+            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockType(tilePos), data, this.world.getTileEntity(tilePos)));
         }
 
         return true;
     }
 
     @Override
-    public boolean setBlockIdData(final @NotNull TilePosc tilePos, final int id, final int data) {
-        this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(id, data, null));
+    public boolean setBlockTypeData(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data) {
+        this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(block, data, null));
         return true;
     }
 
@@ -82,7 +82,7 @@ public class BlocksContainer implements MutableWorldSource {
         if (entry != null) {
             entry.tileEntity = tileEntity;
         } else {
-            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockId(tilePos), this.world.getBlockData(tilePos), tileEntity));
+            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockType(tilePos), this.world.getBlockData(tilePos), tileEntity));
         }
     }
 
@@ -92,7 +92,7 @@ public class BlocksContainer implements MutableWorldSource {
         if (entry != null) {
             entry.tileEntity = null;
         } else {
-            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockId(tilePos), this.world.getBlockData(tilePos), null));
+            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockType(tilePos), this.world.getBlockData(tilePos), null));
         }
     }
 
@@ -114,18 +114,13 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public int getBlockId(final @NotNull TilePosc tilePos) {
+    public @NotNull Block<?> getBlockType(final @NotNull TilePosc tilePos) {
         final @Nullable BlockEntry entry = this.getEntry(tilePos);
         if (entry != null) {
-            return entry.id;
+            return entry.block;
         }
 
-        return 0;
-    }
-
-    @Override
-    public @Nullable Block<?> getBlock(final @NotNull TilePosc tilePos) {
-        return Blocks.getBlock(this.getBlockId(tilePos));
+        return Blocks.AIR;
     }
 
     @Override
@@ -178,24 +173,19 @@ public class BlocksContainer implements MutableWorldSource {
 
     @Override
     public @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        if (block == null) {
-            return Materials.AIR;
-        } else {
-            return block.getMaterial();
-        }
+        final @NotNull Block<?> block = Objects.requireNonNull(this.getBlockType(tilePos));
+        return block.getMaterial();
     }
 
     @Override
     public boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.isSolidRender();
+        return this.getBlockType(tilePos).isSolidRender();
     }
 
     @Override
     public boolean isBlockNormalCube(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
+        final @Nullable Block<?> block = this.getBlockType(tilePos);
+        return block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
     }
 
     @Override
@@ -234,12 +224,12 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     public static class BlockEntry {
-        public int id;
+        public @NotNull Block<?> block;
         public int data;
         public @Nullable TileEntity tileEntity;
 
-        public BlockEntry(final int id, final int data, final @Nullable TileEntity tileEntity) {
-            this.id = id;
+        public BlockEntry(final @NotNull Block<?> block, final int data, final @Nullable TileEntity tileEntity) {
+            this.block = block;
             this.data = data;
             this.tileEntity = tileEntity;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
index 6677a4c1c..6a2ab01c4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -189,7 +189,7 @@ public class Explosion {
             int y1 = chunkposition.y;
             int z1 = chunkposition.z;
 
-            if (this.world.getBlockId(x1, y1, z1) == 0 && Blocks.solid[this.world.getBlockId(x1, y1 - 1, z1)] && this.ExplosionRNG.nextInt(3) == 0) {
+            if (this.world.getBlockId(x1, y1, z1) == Blocks.AIR.id() && Blocks.solid[this.world.getBlockId(x1, y1 - 1, z1)] && this.ExplosionRNG.nextInt(3) == 0) {
                 this.world.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id());
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 305cbeb04..7484e458e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -114,7 +114,7 @@ public class ExplosionCannonball extends Explosion {
                 int k3 = chunkposition.z;
                 int l3 = this.world.getBlockId(i3, j3, k3);
                 int i4 = this.world.getBlockId(i3, j3 - 1, k3);
-                if (l3 == 0 && Blocks.solid[i4] && this.ExplosionRNG.nextInt(3) == 0) {
+                if (l3 == Blocks.AIR.id() && Blocks.solid[i4] && this.ExplosionRNG.nextInt(3) == 0) {
                     this.world.setBlockWithNotify(i3, j3, k3, Blocks.FIRE.id());
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java b/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java
index f6a4a168a..6d65e1c58 100644
--- a/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java
@@ -1,19 +1,23 @@
 package net.minecraft.core.world;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
+import java.util.Objects;
+
 public interface MutableWorldSource
     extends WorldSource {
 
-    boolean setBlockId(final @NotNull TilePosc tilePos, final int id);
+    boolean setBlockType(final @NotNull TilePosc tilePos, final @NotNull Block<?> block);
 
     @Deprecated
     default boolean setBlock(final int x, final int y, final int z, final int id) {
-        return this.setBlockId(new TilePos(x, y, z), id);
+        return this.setBlockType(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
     }
 
     boolean setBlockData(final @NotNull TilePosc tilePos, final int data);
@@ -23,11 +27,11 @@ public interface MutableWorldSource
         return this.setBlockData(new TilePos(x, y, z), data);
     }
 
-    boolean setBlockIdData(final @NotNull TilePosc tilePos, final int id, final int data);
+    boolean setBlockTypeData(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data);
 
     @Deprecated
     default boolean setBlockAndMetadata(final int x, final int y, final int z, final int id, final int data) {
-        return this.setBlockIdData(new TilePos(x, y, z), id, data);
+        return this.setBlockTypeData(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)), data);
     }
 
     void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos, final int value);
diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 7bf468882..3b0e2289d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -361,7 +361,7 @@ public final class SpawnerMobs {
                                     world.entityJoinedWorld(entity);
                                     player.wakeUpPlayer(true, false);
                                     final @NotNull TilePos playerDown = new TilePos(player).down();
-                                    world.playBlockEvent(null, playerDown, LevelListener.EVENT_BLOCK_BREAK, world.getBlockId(playerDown));
+                                    world.playBlockEvent(null, playerDown, LevelListener.EVENT_BLOCK_BREAK, world.getBlockType(playerDown).id());
                                     entity.playLivingSound();
                                     spawnedEntity = true;
                                     spawnedEntityForPlayer = true;
